import sys

with open(sys.argv[1], "rb") as f:
    data = f.read()

def b2r(data, ptr):
    reg = hex(data[ptr])[-1]
    return f"r{reg}"

should_exit = False

regs =dict([(f"r{x}", "") for x in "0123456789sbcdef"])
ptr = 0

while not should_exit:
    try:
        ins = data[ptr]
    except:
        print("done executing")
        break

    match ins:
        case a if hex(a).startswith('0x4'):
            reg = b2r(data, ptr)
            regs[reg] = '0'

        case 0x51:
            ptr += 1
            reg_0 = b2r(data, ptr)
            ptr += 1
            reg_1 = b2r(data, ptr)
            ptr += 1
            reg_2 = b2r(data, ptr)
            regs[reg_2] = str(int(regs[reg_0]) + int(regs[reg_1])) 

        case 0x52:
            ptr += 1
            r = b2r(data, ptr)
            regs[r] += '1'

        case 0x53:
            ptr += 1
            r= b2r(data, ptr)
            regs[r] = regs[r][:-1]

        case 0x54:
            ptr += 1
            reg = b2r(data, ptr)
            regs[reg] = '-' + regs[reg]
            # you can negate a string
            regs[reg] = regs[reg].replace('--', '')

        case 0x55:
            print(regs['rf'])

        case 0x56:
            regs['r0'] = open(regs['r0'], 'r').read().strip()

        case 0x57:
            print("Reached an exit instruction")
            should_exit = True

        case 0x3d:
            ptr += 1
            reg_0 = b2r(data, ptr)
            ptr += 1
            reg_1 = b2r(data, ptr)
            regs[reg_1] = str(ord(regs[reg_0][-1]))

        case 0x3e:
            ptr += 1
            reg_0 = b2r(data, ptr)
            ptr += 1
            reg_1 = b2r(data, ptr)
            regs[reg_1] = chr(int(regs[reg_0]) % 256)

        case 0x3f:
            ptr += 1
            reg_0 = b2r(data, ptr)
            ptr += 1
            reg_1 = b2r(data, ptr)
            ptr += 1
            reg_2 = b2r(data, ptr)
            # this is string concatenation
            regs[reg_2] = regs[reg_0] + regs[reg_1] 


        case 0x28:
            loc = ptr + int(regs['ra'])
            print(f"{ptr}: JUMPING by {regs['ra']} (to {loc})")
            ptr = loc

        case 0x29:
            loc = ptr + int(regs['ra'])
            print(f"{ptr}: JUMPING by {regs['ra']} (to {loc}) IF {regs['rb']} == {regs['rc']}")
            if regs['rb'] == regs['rc']:
                ptr = loc

        case 0x2a:
            loc = ptr + int(regs['ra'])
            print(f"{ptr}: JUMPING by {regs['ra']} (to {loc}) IF {regs['rb']} != ({regs['rc']})")
            if regs['rb'] != regs['rc']:
                ptr = loc

        case 0x2b:
            loc = ptr + int(regs['ra'])
            print(f"{ptr}: JUMPING by {regs['ra']} (to {loc}) IF {regs['rb']} < ({regs['rc']})")
            if regs['rb'] < regs['rc']:
                ptr = loc

        case a if a in range(0x2c, 0x3b+1):
            reg = hex(a-0x2c)[-1]
            regs[f'r{reg}'] = ''

        case other:
            print(f"UNKNOWN INSTR: {hex(other)} at POS {ptr}")
            print(regs)
            assert False

    ptr += 1
